import SyncInitRequest, { serialize_SyncInitRequest, deserialize_SyncInitRequest} from "./syncinitrequest";
import SyncInitResponse, { serialize_SyncInitResponse, deserialize_SyncInitResponse} from "./syncinitresponse";
import PullGetLogRequest, { serialize_PullGetLogRequest, deserialize_PullGetLogRequest} from "./pullgetlogrequest";
import PullGetLogResponse, { serialize_PullGetLogResponse, deserialize_PullGetLogResponse} from "./pullgetlogresponse";
import PullObjectRequest, { serialize_PullObjectRequest, deserialize_PullObjectRequest} from "./pullobjectrequest";
import PullObjectResponse, { serialize_PullObjectResponse, deserialize_PullObjectResponse} from "./pullobjectresponse";
import ServiceMessage, { serialize_ServiceMessage, deserialize_ServiceMessage} from "./servicemessage";
export type {
   SyncInitRequest,
   SyncInitResponse,
   PullGetLogRequest,
   PullGetLogResponse,
   PullObjectRequest,
   PullObjectResponse,
   ServiceMessage,
}
import { IStream, Service } from "./service_server";
export abstract class Sync<T> extends Service<T> {
   public name = "Sync";
   constructor(){
      super();
      this.functions.set("SyncInit", {
         istream: false, input: deserialize_SyncInitRequest,
         rstream: false, ret: serialize_SyncInitResponse
      });
      this.functions.set("PullGetLog", {
         istream: false, input: deserialize_PullGetLogRequest,
         rstream: false, ret: serialize_PullGetLogResponse
      });
      this.functions.set("PullObject", {
         istream: false, input: deserialize_PullObjectRequest,
         rstream: false, ret: serialize_PullObjectResponse
      });
   }

   abstract SyncInit(data: SyncInitRequest, ctx: T): Promise<SyncInitResponse>;

   abstract PullGetLog(data: PullGetLogRequest, ctx: T): Promise<PullGetLogResponse>;

   abstract PullObject(data: PullObjectRequest, ctx: T): Promise<PullObjectResponse>;
}